︠7a0b42bc-226e-4550-ad6c-03e1612ce324︠
# Create a bunch of variables with the same prefix
# Example:
#       makevars('x',3)
# creates variables x1, x2, x3 in the global namespace.
# Return value: a tuple containing the variables.
def makevars(prefix, n):
    return var(' '.join([prefix+str(i) for i in range(n)]))
︡935cc91a-1035-4a21-8edb-c84b6904038b︡︡
︠891bd47e-0858-4793-8a74-20e07826a88b︠
x = makevars('x',5); x
︡45f6d8a9-81a7-4ec5-8ca6-4bcfd2b3febb︡{"stdout": "(x0, x1, x2, x3, x4)"}︡
︠f2ba31de-e92e-4014-9b82-dbc240c3dac6︠
# Defining an expression:
fexpr = sum(sin(v)^2 for v in x); fexpr
︡dcbc6052-a422-4290-b9dc-db9d7cbffb62︡{"stdout": "sin(x4)^2 + sin(x3)^2 + sin(x2)^2 + sin(x1)^2 + sin(x0)^2"}︡
︠d1dcc9c2-9c66-4565-8828-7a8b4a5b18ad︠
# Defining a function
f(tuple(x)) = sum( sum(sin(v)-cos(w) for w in x if w!=v) for v in x); f
︡201514f5-fcb4-4147-8b78-eb3b4c86d461︡{"stdout": "(x0, x1, x2, x3, x4) |--> 4*sin(x4) - 4*cos(x4) + 4*sin(x3) - 4*cos(x3) + 4*sin(x2) - 4*cos(x2) + 4*sin(x1) - 4*cos(x1) + 4*sin(x0) - 4*cos(x0)"}︡
︠e0183e20-f06a-4b33-8add-080fdb045f33︠
# Computing partial derivatives, for example:
diff(fexpr,x1)
︡08495380-0a31-472b-9e1e-a33ce7e35424︡{"stdout": "2*cos(x1)*sin(x1)"}︡
︠f8af6a17-ca81-4854-8ac7-71014911d156︠
# Some computations with the function
print f(0,0,0,0,x4)
print diff(f(2,-1,x2,4,x4),x4)
plot (f(2,-1,3,x3,0),-2*pi,2*pi)
︡dbcad757-762e-4e6d-8f14-a7c9e4fa4b97︡{"stdout": "4 sin(x4) - 4 cos(x4) - 16\n\n                             4 sin(x4) + 4 cos(x4)"}︡
